#include <common.h>
#include "asm/m5282.h"

int checkboard (void)
{
	puts ("Arcturus Networks uCdimm 5282 Board\n");
	return 0;
}

long int initdram (int board_type)
{
	int i;

	mbar_writeShort(MCFSDRAMC_DCR, MCFSDRAMC_DCR_RTIM_6
			| MCFSDRAMC_DCR_RC((15 * CFG_CLK)>>4));
	mbar_writeLong(MCFSDRAMC_DACR0, MCFSDRAMC_DACR_BASE(CFG_SDRAM_BASE)
			| MCFSDRAMC_DACR_CASL(1)
			| MCFSDRAMC_DACR_CBM(3)
			| MCFSDRAMC_DACR_PS_32);
	mbar_writeLong(MCFSDRAMC_DMR0, MCFSDRAMC_DMR_BAM_16M
			| MCFSDRAMC_DMR_V);
	mbar_writeLong(MCFSDRAMC_DACR0, mbar_readLong(MCFSDRAMC_DACR0) 
			| MCFSDRAMC_DACR_IP);
	*(unsigned int *)(CFG_SDRAM_BASE) = 0xA5A59696;
	mbar_writeLong(MCFSDRAMC_DACR0, mbar_readLong(MCFSDRAMC_DACR0) 
			| MCFSDRAMC_DACR_RE);
	for (i=0; i < 2000; i++)
		asm(" nop");
	mbar_writeLong(MCFSDRAMC_DACR0, mbar_readLong(MCFSDRAMC_DACR0) 
			| MCFSDRAMC_DACR_IMRS);
	*(unsigned int *)(CFG_SDRAM_BASE + 0x400) = 0xA5A59696;

	return CFG_SDRAM_SIZE * 1024 * 1024;
}


#if defined(CFG_DRAM_TEST)
int testdram (void)
{
	uint *pstart = (uint *) CFG_MEMTEST_START;
	uint *pend = (uint *) CFG_MEMTEST_END;
	uint *p;

	printf("SDRAM test phase 1:\n");
	for (p = pstart; p < pend; p++)
		*p = 0xaaaaaaaa;

	for (p = pstart; p < pend; p++) {
		if (*p != 0xaaaaaaaa) {
			printf ("SDRAM test fails at: %08x\n", (uint) p);
			return 1;
		}
	}

	printf("SDRAM test phase 2:\n");
	for (p = pstart; p < pend; p++)
		*p = 0x55555555;

	for (p = pstart; p < pend; p++) {
		if (*p != 0x55555555) {
			printf ("SDRAM test fails at: %08x\n", (uint) p);
			return 1;
		}
	}

	printf("SDRAM test passed.\n");
	return 0;
}
#endif

#if 0
void hw_watchdog_reset(void)
{
	/* Temporary code to flip led on uCevolution */
	if (mbar_readByte(MCFGPTA_PORT) == 0x0F)
		mbar_writeByte(MCFGPTA_PORT, 0x00);
	else
		mbar_writeByte(MCFGPTA_PORT, 0x0F);

	printf("WCNTR: %i\n", mbar_readShort(MCFWTM_WCNTR));
	//__asm__("trap #1");
	//__asm__("halt");
	mbar_writeShort(0x140006, 0x5555);
	mbar_writeShort(0x140006, 0xAAAA);
}
#endif
