/*
 * mcfdmatimer.h -- ColdFire internal TIMER support defines.
 *
 *		 N.Z.Gustavson
 *      (C) Copyright 2005, EMAC.Inc. (www.emacinc.com)
 * 	 based on mcftimer.h - using new 32 bit DMA timers instead of old GP timers.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/****************************************************************************/
#ifndef	    mcfdmatimer_h
#define	mcfdmatimer_h
/****************************************************************************/

#include <linux/config.h>

#if defined(CONFIG_M5282)
#define MCFDMATIMER_BASE1				0x400        	/* Base address of DMATIMER1 */
#define MCFDMATIMER_BASE2			    0x440        	/* Base address of DMATIMER2 */
#define MCFDMATIMER_BASE3				0x480        	/* Base address of DMATIMER3 */
#define MCFDMATIMER_BASE4				0x4C0			/* Base address of DMATIMER4 */
#endif

/*
 *	Define the TIMER register set addresses.
 */
#define	MCFDMATIMER_TMR	0x00		/* Timer Mode reg (r/w) */
#define	MCFDMATIMER_TRR		0x04		/* Timer Reference (r/w) */
#define	MCFDMATIMER_TCR		0x08		/* Timer Capture reg (r/w) */
#define	MCFDMATIMER_TCN		0x0c		/* Timer Counter reg (r/w) */


/*
 *	Bit definitions for the Timer Mode Register (TMR).
 * Same as general purpose timers on 5272
 */
#define	MCFDMATIMER_TMR_PREMASK	0xff00		/* Prescalar mask */
#define	MCFDMATIMER_TMR_DISCE	0x0000		/* Disable capture */
#define	MCFDMATIMER_TMR_ANYCE	0x00c0		/* Capture any edge */
#define	MCFDMATIMER_TMR_FALLCE	0x0080		/* Capture fallingedge */
#define	MCFDMATIMER_TMR_RISECE	0x0040		/* Capture rising edge */
#define	MCFDMATIMER_TMR_ENOM	0x0020		/* Enable output toggle */
#define	MCFDMATIMER_TMR_DISOM	0x0000		/* Do single output pulse  */
#define	MCFDMATIMER_TMR_ENORI	0x0010		/* Enable ref interrupt */
#define	MCFDMATIMER_TMR_DISORI	0x0000		/* Disable ref interrupt */
#define	MCFDMATIMER_TMR_RESTART	0x0008		/* Restart counter */
#define	MCFDMATIMER_TMR_FREERUN	0x0000		/* Free running counter */
#define	MCFDMATIMER_TMR_CLKTIN	0x0006		/* Input clock is DTIN */
#define	MCFDMATIMER_TMR_CLK16	0x0004		/* Input clock is /16 */
#define	MCFDMATIMER_TMR_CLK1	0x0002		/* Input clock is /1 */
#define	MCFDMATIMER_TMR_CLKSTOP	0x0000		/* Stop counter */
#define	MCFDMATIMER_TMR_ENABLE	0x0001		/* Enable timer */
#define	MCFDMATIMER_TMR_DISABLE	0x0000		/* Disable timer */





/****************************************************************************/
#endif	/* mcftimer_h */
